--
-- PlayerCam
--
-- @autor	nilBrain @VertexDezign
-- @date	17.04.2025
-- Copyright (C) nilBrain, Confidential, All Rights Reserved.



PlayerCam = {};
PlayerCam.Y_OFFSET = 0;


local inject_PlayerCamerainitialiseCameraNodes = PlayerCamera.initialiseCameraNodes;
function PlayerCamera:initialiseCameraNodes()
	inject_PlayerCamerainitialiseCameraNodes(self);
	local x, y, z = getTranslation(self.firstPersonCamera);
	local rotXNode = createTransformGroup("camRotX");
	link(getParent(self.firstPersonCamera), rotXNode);
	setTranslation(rotXNode, x, y, z);
	link(rotXNode, self.firstPersonCamera);
	setTranslation(self.firstPersonCamera, 0, 0, 0);
	self.cameraRotationXNode = rotXNode;
end;


function PlayerCamera:setOffsetY(offsetY)
	offsetY = offsetY or 0;
	local baseOffset = PlayerCam.Y_OFFSET;
	self.offsetY = baseOffset + offsetY;
end

function PlayerCam:loadMap(name)
    self.step = 0.01;
	self.currentStep = 0;
	self.fovAngleBackup = g_gameSettings:getValue(GameSettings.SETTING.FOV_Y);
	self.baseCamPos = nil;
end;

function PlayerCam:mouseEvent(posX, posY, isDown, isUp, button)
    local player = g_localPlayer;
    local controlledVehicle = player ~= nil and player:getCurrentVehicle() or nil;

	if player == nil then
		return;
	elseif player.camera == nil then
		return;
	end;

	local camera = player.camera;

	self.cameraId = nil;
	if controlledVehicle then
		self.cameraId = getCamera();
	elseif camera.isFirstPerson then
		self.cameraId = camera.firstPersonCamera;
	end;

	if g_gui:getIsGuiVisible() then
		return;
	end;

	if self.cameraId ~= nil then
		self.newFovy = getFovY(self.cameraId);

		local isLeftButtonPressed = Input.isMouseButtonPressed(Input.MOUSE_BUTTON_LEFT);
		local isRightButtonPressed = Input.isMouseButtonPressed(Input.MOUSE_BUTTON_RIGHT);

		if (not isLeftButtonPressed) and isRightButtonPressed then
			--only zoom in indoreCam
			if controlledVehicle and controlledVehicle.controlledVehicle ~= nil then
				local vCam = controlledVehicle:controlledVehicle();
				if not vCam.isInside then
					return;
				end;
			end;

			if Input.isMouseButtonPressed(Input.MOUSE_BUTTON_WHEEL_UP) then
				setFovY(self.cameraId, self.newFovy - (self.step*0.3));
			end;

			if Input.isMouseButtonPressed(Input.MOUSE_BUTTON_WHEEL_DOWN) then		
				setFovY(self.cameraId, self.newFovy + (self.step*0.3));
			end;

			if Input.isMouseButtonPressed(Input.MOUSE_BUTTON_MIDDLE) then
				setFovY(self.cameraId, self.fovAngleBackup);
			end;

		elseif (not isLeftButtonPressed) and (not isRightButtonPressed) then
			if camera.isFirstPerson then
				if Input.isMouseButtonPressed(Input.MOUSE_BUTTON_WHEEL_DOWN) and self.currentStep > -6.0 then
					self.currentStep = self.currentStep - self.step;
				end;

				if Input.isMouseButtonPressed(Input.MOUSE_BUTTON_WHEEL_UP) then
					self.currentStep = self.currentStep + self.step;
				end;

				if Input.isMouseButtonPressed(Input.MOUSE_BUTTON_MIDDLE) then
					self.currentStep = 0;
				end;
				PlayerCam.Y_OFFSET = self.currentStep;
			end;
		elseif isLeftButtonPressed and (not isRightButtonPressed) then
			if camera.isFirstPerson then
				local rotXNode = camera.cameraRotationXNode;
				if rotXNode ~= nil then
					if Input.isMouseButtonPressed(Input.MOUSE_BUTTON_WHEEL_UP) then
						rotate(rotXNode, 0, 0, self.step);
					end;

					if Input.isMouseButtonPressed(Input.MOUSE_BUTTON_WHEEL_DOWN) then
						rotate(rotXNode, 0, 0, -self.step);
					end;

					if Input.isMouseButtonPressed(Input.MOUSE_BUTTON_MIDDLE) then
						setRotation(rotXNode, 0, 0, 0);
					end;
				end;
			end;
		end;
	end;
end;

addModEventListener(PlayerCam);